Attribute VB_Name = "Module1"
Enum Statuses
    Disconnected
    Connecting
    authorizing
    Connected
    Transfering
End Enum

Enum TransferTypes
    none
    List
    ToFile
End Enum

Global TransferType As TransferTypes
Global Status As Statuses

Global UserName As String
Global Password As String
Global SystemName As String
Global SystemAddress As String
Global Port As Long
Global LocalDir As String
Global RemoteDir As String

Global IncomingBuffer As String

Dim RetrieveCommand As String

Global LISTResults As String

Global ByteCount As Long

Sub ChangeState()
If Status = Connected Or Status = Connecting Or Status = Transfering Or Status = authorizing Then
    Form1.cmdConnect.Enabled = False
    Form1.cmdDisconnect.Enabled = True
    Form1.Frame1.Enabled = False
ElseIf Status = Disconnected Then
    Form1.cmdConnect.Enabled = True
    Form1.cmdDisconnect.Enabled = False
    Form1.Frame1.Enabled = True
End If
End Sub

Sub ProcessBuffer()
'This looks for whole lines (terminated with CRLF) and interperates them
' then acts as appropiate
Dim CommandLine As String
StartOfProcess:
CommandLine = GetLine(IncomingBuffer)
If CommandLine = "" Then Exit Sub
Select Case Val(Mid$(CommandLine, 1, 3))
    Case 220 'Can try to log in
        Form1.ControlConnection.SendData "USER " & UserName & vbCr & vbLf
        Form1.StatusBar.SimpleText = "Sending Username"
    Case 331 'Username ok, send password
        Form1.ControlConnection.SendData "PASS " & Password & vbCr & vbLf
        Form1.StatusBar.SimpleText = "Sending Password"
    Case 230 'User Logged In
        Form1.ControlConnection.SendData "PWD" & vbCr & vbLf 'get the current directory
        Form1.StatusBar.SimpleText = "Logged in, getting directory name"
    Case 257 'Current DIR response
        Start = InStr(4, CommandLine, Chr(34)) + 1
        Ending = InStr(Start, CommandLine, Chr(34))
        Form1.txtRemoteDirectory = Mid$(CommandLine, Start, Ending - Start)
        Form1.StatusBar.SimpleText = "Got directory name"
        
        RetrieveCommand = "LIST" & vbCr & vbLf
        LISTResults = ""
        TransferType = List
        SetupDataConnection
        Form1.StatusBar.SimpleText = "Getting directory contents"
    
    Case 200 'Command OK
        If TransferType <> none Then 'It is ready to send the file
            Form1.ControlConnection.SendData RetrieveCommand
        End If
    Case 221 'Goodbye
        'Form1.ControlConnection.Close
        Form1.StatusBar.SimpleText = "Disconnecting"
    
    Case 226 ' Transfer Complete
        Form1.StatusBar.SimpleText = "Transfer Complete"
End Select

GoTo StartOfProcess
End Sub

Function GetLine(InputString As String) As String
'This gets the line terminated with a CRLF. If no CRLF exists it returns a
'zero length string
Dim Position As Integer
Position = InStr(1, InputString, vbCr & vbLf)
If Position = 0 Then Exit Function

GetLine = Mid$(InputString, 1, Position - 1)
InputString = Mid$(InputString, Position + 2)
End Function

Sub SetupDataConnection()
    
    Form1.DataConnection.Close
    Form1.DataConnection.Listen
    
    Start = 1
    Ending = InStr(Start, Form1.DataConnection.LocalIP, ".")
    getstring = Mid$(Form1.DataConnection.LocalIP, Start, Ending - Start) & ","
    Start = Ending + 1
    Ending = InStr(Start, Form1.DataConnection.LocalIP, ".")
    getstring = getstring & Mid$(Form1.DataConnection.LocalIP, Start, Ending - Start) & ","
    Start = Ending + 1
    Ending = InStr(Start, Form1.DataConnection.LocalIP, ".")
    getstring = getstring & Mid$(Form1.DataConnection.LocalIP, Start, Ending - Start) & ","
    Start = Ending + 1
    Ending = InStr(Start, Form1.DataConnection.LocalIP, ".")
    getstring = getstring & Mid$(Form1.DataConnection.LocalIP, Start) & ","
    
    getstring = getstring & HiByte(Form1.DataConnection.LocalPort) & ","
    getstring = getstring & LoByte(Form1.DataConnection.LocalPort) & ""
    Form1.ControlConnection.SendData "PORT " & getstring & vbCr & vbLf
End Sub

Function LoByte(ByVal IntegerVal As Integer) As Byte
    LoByte = IntegerVal And &HFF&
End Function

Function HiByte(ByVal IntegerVal As Integer) As Byte
     If IntegerVal = 0 Then
         highbyte = 0
         Exit Function
     End If

    HiByte = IntegerVal \ &H100 And &HFF&
End Function

Sub ProcessList()
Dim LineBuffer As String
Form1.RemoteFiles.Clear
StartOfProceedure:
LineBuffer = GetLine(LISTResults)
If LineBuffer = "" Then Exit Sub
    If Mid$(LineBuffer, 1, 1) = "d" Then
        'A directory
        Form1.RemoteFiles.AddItem "DIR:" & Mid$(LineBuffer, 49)
    ElseIf Mid$(LineBuffer, 1, 1) = "-" Then
        'A file
        Form1.RemoteFiles.AddItem "FILE:" & Mid$(LineBuffer, 49)
    End If
GoTo StartOfProceedure
End Sub
